<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des tranches d'âge n'ont pas pu être chargées."
    />
    <template v-else-if="ageGroupsCounts">
      <h2 class="fr-h5">Tranches d'âge</h2>
      <StatsPie
        v-if="ageGroupsCounts.length"
        pie-label="Répartition des tranches d'âge"
        :stats="ageGroupsCounts"
        :total-count="beneficiaryCount"
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des tranches
        d'âge.
      </p>
    </template>
  </div>
</template>

<script setup>
  import dayjs from 'dayjs'
  import {
    ageGroupToDateRange,
    dateIsBetween,
    dateIsSameOrBefore,
    dateIsSameOrAfter
  } from '~/utils'
  import { AGE_GROUP_OPTIONS } from '~/utils/constants/age-groups'
  import { AGE_GROUPS_COLORS } from '~/utils/constants/chart'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: ageGroupsCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData('ageGroupsCounts', loadAgeGroupsCounts, {
    server: false,
    default: () => 0
  })

  watch(() => props.filters, refresh)

  async function loadAgeGroupsCounts() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems('beneficiary', {
      groupBy: 'birthdate',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const ageGroupsFilters = {}
      AGE_GROUP_OPTIONS.forEach((_, key) => {
        const { lower, upper } = ageGroupToDateRange(key)
        ageGroupsFilters[key] = {
          lower,
          upper
        }
      })
      const ageGroupsCounts = {}
      res.data.data.forEach(({ birthdate, countDistinct }) => {
        if (birthdate) {
          const convertedBirthdate = dayjs(birthdate)
          Object.entries(ageGroupsFilters).forEach(([key, value]) => {
            if (value.lower && value.upper) {
              if (dateIsBetween(convertedBirthdate, value.lower, value.upper)) {
                ageGroupsCounts[key] =
                  (ageGroupsCounts[key] || 0) + parseInt(countDistinct.id)
              }
            } else if (value.lower) {
              if (dateIsSameOrAfter(convertedBirthdate, value.lower)) {
                ageGroupsCounts[key] =
                  (ageGroupsCounts[key] || 0) + parseInt(countDistinct.id)
              }
            } else if (value.upper) {
              if (dateIsSameOrBefore(convertedBirthdate, value.upper)) {
                ageGroupsCounts[key] =
                  (ageGroupsCounts[key] || 0) + parseInt(countDistinct.id)
              }
            }
          })
        } else {
          ageGroupsCounts[birthdate] =
            (ageGroupsCounts[birthdate] || 0) + parseInt(countDistinct.id)
        }
      })
      const ageGroupsCountsResults = Object.entries(ageGroupsCounts).map(
        ([key, value]) => ({
          key,
          label: groupLabel(key),
          color: AGE_GROUPS_COLORS[key],
          count: value
        })
      )
      ageGroupsCountsResults.sort((a, b) => b.count - a.count)
      return ageGroupsCountsResults
    }
    throw new Error(errorResponseMessage(res))
  }

  function groupLabel(group) {
    if (group === 'null') return 'Non renseigné'
    return AGE_GROUP_OPTIONS.get(group)
  }
</script>
